Subject: Re: linux-next: workqueues tree build failure

From: Mark Brown <[email-masked]>
Date: Thu, 26 Nov 2009 12:56:59 +0000

On Thu, Nov 26, 2009 at 07:40:25AM -0500, Andy Walls wrote:

> I'm not sure doing things like I2C transactions in the in the top half
> of the IRQ handler is generally viable.  On shared IRQ lines, wouldn't
> this hold off the interrupt for another device for too long?

You're going to need to do I2C I/O to acknowledge and deassert the
interrupt on most of these devices so if someone's shared the IRQ line
with something that's too latency sensitive the hardware is broken
anyway.

> Workhandlers for deferring work are a nice way to avoid such bad system
> level interactions.

In order to cope with the fact that the IRQ can't be deasserted without
talking to the device it will almost always be masked while waiting for
the deferred work.